diff --git a/hubs/static/client/app/core/reducers/widget.js b/hubs/static/client/app/core/reducers/widget.js
new file mode 100644
index 0000000..524e024
--- /dev/null
+++ b/hubs/static/client/app/core/reducers/widget.js
@@ -0,0 +1,29 @@
+import {
+  WIDGET_PUT_REQUEST, WIDGET_PUT_SUCCESS, WIDGET_PUT_FAILURE,
+  } from '../actions/widget';
+import { WIDGET_NEEDS_UPDATE } from '../actions/sse';
+
+
+export default function singleWidgetReducer(state, action) {
+  switch (action.type) {
+    case WIDGET_PUT_REQUEST:
+      return {
+        ...state,
+        // Optimistic update
+        config: action.config,
+        old: {config: state.config},
+      };
+    case WIDGET_PUT_SUCCESS:
+      return {
+        ...action.widgetProps,
+      };
+    case WIDGET_PUT_FAILURE:
+      return {
+        ...state,
+        // Optimism failed... ;-(
+        config: state.old.config,
+      };
+    default:
+      return state
+  }
+}
diff --git a/hubs/static/client/app/core/reducers/widgets.js b/hubs/static/client/app/core/reducers/widgets.js
new file mode 100644
index 0000000..014b85c
--- /dev/null
+++ b/hubs/static/client/app/core/reducers/widgets.js
@@ -0,0 +1,185 @@
+import { combineReducers } from 'redux';
+import { arrayMove } from 'react-sortable-hoc';
+import {
+  HUB_WIDGETS_FETCH_REQUEST, HUB_WIDGETS_FETCH_SUCCESS, HUB_WIDGETS_FETCH_FAILURE,
+  HUB_WIDGETS_EDIT_MODE,
+  HUB_WIDGETS_AVAIL_REQUEST, HUB_WIDGETS_AVAIL_SUCCESS, HUB_WIDGETS_AVAIL_FAILURE,
+  } from '../actions/widgets';
+import {
+  WIDGET_PUT_SUCCESS, WIDGET_DELETE_SUCCESS,
+  WIDGET_WILL_UPDATE, WIDGET_DID_UPDATE,
+  HUB_WIDGETS_ADD_REQUEST, HUB_WIDGETS_ADD_FAILURE,
+  WIDGET_MOVE_REQUEST, WIDGET_MOVE_FAILURE,
+  WIDGET_OPEN_CONFIG, WIDGET_CLOSE_CONFIG,
+  } from '../actions/widget';
+import { WIDGET_NEEDS_UPDATE } from '../actions/sse';
+import singleWidgetReducer from './widget';
+
+
+function widgetsAreLoading(state=false, action) {
+  switch (action.type) {
+    case HUB_WIDGETS_FETCH_REQUEST:
+    case HUB_WIDGETS_ADD_REQUEST:
+    case HUB_WIDGETS_AVAIL_REQUEST:
+    case WIDGET_MOVE_REQUEST:
+      return true;
+    case HUB_WIDGETS_FETCH_SUCCESS:
+    case HUB_WIDGETS_FETCH_FAILURE:
+    case HUB_WIDGETS_ADD_FAILURE:
+    case HUB_WIDGETS_AVAIL_SUCCESS:
+    case HUB_WIDGETS_AVAIL_FAILURE:
+    case WIDGET_MOVE_FAILURE:
+      return false;
+    default:
+      return state
+  }
+}
+
+
+function widgetList(position) {
+  return (state=[], action) => {
+    switch (action.type) {
+      case HUB_WIDGETS_FETCH_SUCCESS:
+        return action.widgets.filter(
+          widget => (widget.position === position)
+        ).map(widget => widget.idx);
+      case WIDGET_DELETE_SUCCESS:
+        return state.filter((idx) => (idx != action.widgetId));
+      case WIDGET_MOVE_REQUEST:
+        // Optimistic update
+        if (action.position !== position) {
+          return state;
+        }
+        return arrayMove(state, action.oldIndex, action.newIndex);
+      case WIDGET_MOVE_FAILURE:
+        if (action.position !== position) {
+          return state;
+        }
+        return arrayMove(state, action.newIndex, action.oldIndex);
+      default:
+        return state
+    }
+  }
+}
+
+
+function widgetsNeedUpdate(state=[], action) {
+  switch (action.type) {
+    case HUB_WIDGETS_FETCH_SUCCESS:
+      return action.widgets.map((widget) => (widget.idx));
+    case WIDGET_DELETE_SUCCESS:
+    case WIDGET_WILL_UPDATE:
+      if (state.indexOf(action.widgetId) === -1) {
+        return state;
+      } else {
+        return state.filter((idx) => (idx != action.widgetId));
+      }
+    case WIDGET_PUT_SUCCESS:
+    case WIDGET_NEEDS_UPDATE:
+      return [...state, action.widgetId];
+    default:
+      return state
+  }
+}
+
+
+function widgetsById(state={}, action){
+  let newState;
+  switch (action.type) {
+    case HUB_WIDGETS_FETCH_SUCCESS:
+      newState = {};
+      action.widgets.forEach((widget) => {
+        newState[widget.idx] = widget;
+      });
+      return newState;
+    case WIDGET_DELETE_SUCCESS:
+      newState = Object.assign({}, state);
+      delete newState[action.widgetId];
+      return newState;
+    default:
+      if (!action.widgetId) {
+        return state;
+      }
+      let widget = state[action.widgetId];
+      return {
+        ...state,
+        [action.widgetId]: singleWidgetReducer(widget, action),
+      };
+  }
+}
+
+
+export const widgetsReducer = combineReducers({
+  isLoading: widgetsAreLoading,
+  left: widgetList("left"),
+  right: widgetList("right"),
+  byId: widgetsById,
+  needUpdate: widgetsNeedUpdate,
+});
+
+
+
+/* Available widgets */
+
+
+function availWidgetsList(position) {
+  return (state=[], action) => {
+    switch (action.type) {
+      case HUB_WIDGETS_AVAIL_SUCCESS:
+        return action.widgets.filter(
+          widget => (
+            widget.position === position || widget.position === "both"
+          )
+        ).map(widget => widget.name);
+      default:
+        return state
+    }
+  }
+}
+
+function availWidgetsByName(state={}, action){
+  let newState = {};
+  switch (action.type) {
+    case HUB_WIDGETS_AVAIL_SUCCESS:
+      action.widgets.forEach((widget) => {
+        newState[widget.name] = widget;
+      });
+      return newState;
+    default:
+      return state
+  }
+}
+
+export const availableWidgetsReducer = combineReducers({
+  isLoading: widgetsAreLoading,
+  left: availWidgetsList("left"),
+  right: availWidgetsList("right"),
+  byName: availWidgetsByName,
+});
+
+
+
+/* UI */
+
+export function widgetsEditMode(state=false, action) {
+  switch (action.type) {
+    case HUB_WIDGETS_EDIT_MODE:
+      return action.editMode;
+    default:
+      return state
+  }
+}
+
+
+export function widgetConfigDialogOpen(state=false, action) {
+  switch (action.type) {
+    case WIDGET_OPEN_CONFIG:
+      return action.widgetId;
+    case WIDGET_CLOSE_CONFIG:
+    case WIDGET_PUT_SUCCESS:
+    case WIDGET_DELETE_SUCCESS:
+      return false;
+    default:
+      return state
+  }
+}
diff --git a/hubs/static/client/app/core/utils.js b/hubs/static/client/app/core/utils.js
new file mode 100644
index 0000000..0699a93
--- /dev/null
+++ b/hubs/static/client/app/core/utils.js
@@ -0,0 +1,88 @@
+import React from 'react';
+import fetch from 'isomorphic-fetch';
+import Loadable from 'react-loadable';
+
+
+export function backendCall(url, fetchConfig, json=false) {
+  console.log("Calling backend:", url, fetchConfig);
+  const baseFetchConfig = {
+    credentials: "same-origin",
+    headers: {"Content-Type": "application/json"},
+  }
+  fetchConfig = Object.assign({}, baseFetchConfig, fetchConfig);
+  return fetch(url, {...baseFetchConfig, ...fetchConfig}).then(
+    (response) => {
+      if (response.ok) {
+        return json ? response.json() : response.text();
+      } else {
+        return response.text().then((msg) => {
+          throw new Error(msg);
+        });
+      }
+    }
+  ).catch((error) => {
+    console.error(error.message);
+    throw error;
+  });
+}
+
+
+export function apiCall(url, fetchConfig) {
+  return backendCall(url, fetchConfig, true).then(result => {
+    if (result.status === "OK") {
+      return result.data;
+    } else {
+      throw new Error(result.message);
+    }
+  });
+}
+
+
+export function makeLoadable(loader, loading) {
+  const renderDefault = (loaded, props) => {
+    const Component = loaded.default;
+    return <Component {...props} />;
+  }
+  return Loadable({
+    loader,
+    loading,
+    render: renderDefault,
+    delay: 200,
+  });
+}
+
+export function makeLoadingComponent(loadingText, errorText) {
+  class LoadingComponent extends React.Component {
+    render() {
+      // Handle the loading state
+      if (this.props.isLoading) {
+        if (this.props.timedOut) {
+          // In case we've timed out loading our other component.
+          return <div className="text-warning">Loader timed out!</div>;
+        } else if (this.props.pastDelay) {
+          // Display a loading screen after a set delay.
+          return (
+            <div className="text-muted">
+              {loadingText}
+            </div>
+          );
+        } else {
+          // Don't flash "Loading..." when we don't need to.
+          return null;
+        }
+      }
+      // Handle the error state
+      else if (this.props.error) {
+        return (
+          <div>
+            {errorText}
+          </div>
+        );
+      }
+      else {
+        return null;
+      }
+    }
+  }
+  return LoadingComponent;
+}
diff --git a/hubs/static/client/app/widgets/feed/Config.js b/hubs/static/client/app/widgets/feed/Config.js
new file mode 100644
index 0000000..1fc4fa8
--- /dev/null
+++ b/hubs/static/client/app/widgets/feed/Config.js
@@ -0,0 +1,11 @@
+import React from 'react';
+import SimpleWidgetConfig from '../../components/SimpleWidgetConfig';
+
+
+// Use the default configuration, it's sufficient.
+
+export default function Config(props) {
+  return (
+    <SimpleWidgetConfig {...props} />
+  );
+}
diff --git a/hubs/static/client/app/widgets/feed/Widget.js b/hubs/static/client/app/widgets/feed/Widget.js
new file mode 100644
index 0000000..31e6f6f
--- /dev/null
+++ b/hubs/static/client/app/widgets/feed/Widget.js
@@ -0,0 +1,66 @@
+import React from 'react';
+import {
+  widgetDidUpdate,
+  widgetWillUpdate
+  } from "../../core/actions/widget";
+import ItemsGetter from '../../components/feed/ItemsGetter';
+import Feed from '../../components/feed/Feed';
+import WidgetChrome from '../../components/WidgetChrome';
+
+
+export default class Widget extends React.PureComponent {
+
+  propTypes: {
+    widget: PropTypes.object.isRequired,
+    editMode: PropTypes.bool,
+    needsUpdate: PropTypes.bool,
+  }
+
+  constructor(props) {
+    super(props);
+    this.state = {
+      items: [],
+      loaded: false,
+    };
+    this.handleServerData = this.handleServerData.bind(this);
+    this.handleServerRequestStart = this.handleServerRequestStart.bind(this);
+  }
+
+  handleServerData(data) {
+    this.setState({
+      items: data,
+      loaded: true,
+    },
+      () => (
+        this.props.dispatch(widgetDidUpdate(this.props.widget.idx))
+      )
+    );
+  }
+
+  handleServerRequestStart() {
+    this.props.dispatch(widgetWillUpdate(this.props.widget.idx));
+  }
+
+  render() {
+    return (
+      <WidgetChrome
+        widget={this.props.widget}
+        editMode={this.props.editMode}
+        >
+        <ItemsGetter
+          url={this.props.widget.url}
+          useSSE={true}
+          needsUpdate={this.props.needsUpdate}
+          handleData={this.handleServerData}
+          onRequestStart={this.handleServerRequestStart}
+          >
+          <Feed
+            items={this.state.items}
+            loaded={this.state.loaded}
+            />
+        </ItemsGetter>
+      </WidgetChrome>
+    );
+  }
+
+}
diff --git a/hubs/static/client/app/widgets/halp/Config.js b/hubs/static/client/app/widgets/halp/Config.js
new file mode 100644
index 0000000..8f48cff
--- /dev/null
+++ b/hubs/static/client/app/widgets/halp/Config.js
@@ -0,0 +1,206 @@
+import React from 'react';
+import {
+  defineMessages,
+  injectIntl,
+  FormattedMessage,
+  } from 'react-intl';
+import CompletionInput from '../../components/CompletionInput';
+import "./halp.css";
+
+
+const messages = defineMessages({
+  title_add: {
+    id: "hubs.widgets.halp.config.title.add",
+    defaultMessage: "Adding \"halp\" widget",
+  },
+  title_edit: {
+    id: "hubs.widgets.halp.config.title.edit",
+    defaultMessage: "Configuring \"halp\" widget",
+  },
+  followed_hubs: {
+    id: "hubs.widgets.halp.config.followed_hubs",
+    defaultMessage: "Followed hubs:",
+  },
+  no_hubs: {
+    id: "hubs.widgets.halp.config.no_hubs",
+    defaultMessage: "No hubs. Use the form to the right to add some.",
+  },
+  main_title: {
+    id: "hubs.widgets.halp.config.main_title",
+    defaultMessage: "Track help requests in hubs",
+  },
+  main_subtitle: {
+    id: "hubs.widgets.halp.config.main_subtitle",
+    defaultMessage: "Enter a team name below to add it to the list of hubs this widget will follow.",
+  },
+  placeholder: {
+    id: "hubs.widgets.halp.config.placeholder",
+    defaultMessage: "Enter team name here...",
+  },
+  add: {
+    id: "hubs.widgets.halp.config.add",
+    defaultMessage: "Add",
+  },
+  per_page: {
+    id: "hubs.widgets.halp.config.per_page",
+    defaultMessage: "Requests per page:",
+  },
+  per_page_help: {
+    id: "hubs.widgets.halp.config.per_page_help",
+    defaultMessage: "The number of requests per page to display.",
+  },
+  close: {
+    id: "hubs.widgets.halp.config.close",
+    defaultMessage: "Close",
+  },
+  cancel: {
+    id: "hubs.widgets.halp.config.cancel",
+    defaultMessage: "Cancel",
+  },
+  save: {
+    id: "hubs.widgets.halp.config.save",
+    defaultMessage: "Save",
+  },
+  remove_widget: {
+    id: "hubs.widgets.halp.config.remove_widget",
+    defaultMessage: "Remove this widget",
+  },
+});
+
+
+export default class Config extends React.Component {
+
+  constructor(props) {
+    super(props);
+    this.state = {
+      selectedHub: null,
+    }
+    this.getFollowedHubs = this.getFollowedHubs.bind(this);
+    this.handleAddClicked = this.handleAddClicked.bind(this);
+    this.handleHubSelected = this.handleHubSelected.bind(this);
+    this.handlePerPageChanged = this.handlePerPageChanged.bind(this);
+  }
+
+  getFollowedHubs() {
+    return this.props.values.hubs || [];
+  }
+
+  addHub(name) {
+    let config = this.getFollowedHubs();
+    if (config.indexOf(name) === -1) {
+      config.push(name);
+    }
+    this.props.setConfig("hubs", config);
+  }
+
+  removeHub(name) {
+    let config = this.getFollowedHubs();
+    config.splice(config.indexOf(name), 1);
+    this.props.setConfig("hubs", config);
+  }
+
+  handleAddClicked(e) {
+    e.preventDefault();
+    if (this.state.selectedHub === null) {
+      console.log("No hub to add!");
+      return;
+    }
+    this.addHub(this.state.selectedHub);
+    this.setState({selectedHub: null});
+  }
+
+  handleHubSelected(e) {
+    this.setState({selectedHub: e.target.value});
+  }
+
+  handlePerPageChanged(e) {
+    this.props.setConfig("per_page", e.target.value);
+  }
+
+  render() {
+    let followedHubs = this.getFollowedHubs();
+    followedHubs = followedHubs.map((hub, idx) => {
+      return (
+        <li key={hub}>
+          <span className="hub">{hub}</span>
+          <span className="fa fa-times remove-hub"
+                onClick={(e) => {this.removeHub(hub)}}
+            />
+        </li>
+        );
+    });
+
+    /*
+    const IntlCompletionInput = injectIntl((props) => (
+        <CompletionInput
+          inputProps={{
+            name: "hub-add",
+            placeholder: props.intl.formatMessage(messages.placeholder),
+          }}
+          url={props.widget.urls.allHubs}
+          onChange={this.handleHubSelected}
+          />
+    ));
+              //<IntlCompletionInput {...this.props} />
+    */
+
+    return (
+      <div className="row widget-halp-config">
+        <div className="col-sm-4 hubs-list">
+          <FormattedMessage {...messages.followed_hubs} tagName="h5" />
+          {followedHubs.length === 0 ?
+            <p>
+              <FormattedMessage {...messages.no_hubs} tagName="small" />
+            </p>
+          :
+            <ul className="list-unstyled">
+              {followedHubs}
+            </ul>
+          }
+        </div>
+        <div className="col-sm-8 form-side">
+          <FormattedMessage {...messages.main_title} tagName="h4" />
+          <FormattedMessage {...messages.main_subtitle} tagName="p" />
+          <form onSubmit={this.handleAddClicked}>
+            <fieldset className="row">
+              <div className="col-sm-9">
+                <CompletionInput
+                  inputProps={{
+                    name: "hub-add",
+                    placeholder: "Enter team name here...",
+                    value: this.state.selectedHub || "",
+                  }}
+                  url={this.props.widget.urls.allHubs}
+                  onChange={this.handleHubSelected}
+                  />
+              </div>
+              <div className="col-sm-3">
+                <button className="btn btn-info" onClick={this.handleAddClicked}>
+                  <FormattedMessage {...messages.add} />
+                </button>
+              </div>
+            </fieldset>
+          </form>
+          <fieldset className="row">
+            <label className="col-sm-6 control-label">
+              <FormattedMessage {...messages.per_page} />
+            </label>
+            <div className="col-sm-6">
+              <input
+                name="per_page"
+                type="number"
+                value={this.props.values.per_page || "5"}
+                onChange={this.handlePerPageChanged}
+                className="form-control input-sm"
+                />
+            </div>
+            <div className="col-sm-12 text-muted">
+              <FormattedMessage {...messages.per_page_help} tagName="small" />
+            </div>
+          </fieldset>
+        </div>
+      </div>
+    );
+  }
+
+}
diff --git a/hubs/static/client/app/widgets/halp/Hub.js b/hubs/static/client/app/widgets/halp/Hub.js
new file mode 100644
index 0000000..7728662
--- /dev/null
+++ b/hubs/static/client/app/widgets/halp/Hub.js
@@ -0,0 +1,20 @@
+import React from 'react';
+
+
+export default class Hub extends React.Component {
+
+  onClick(e) {
+    e.preventDefault();
+    this.props.onClick(this.props.name);
+  }
+
+  render() {
+    var activeClass = this.props.active ? "active" : "inactive";
+    return (
+      <span
+        className={"hub " + activeClass}
+        onClick={this.onClick.bind(this)}
+        >{"@" + this.props.name}</span>
+    );
+  }
+}
diff --git a/hubs/static/client/app/widgets/halp/HubsList.js b/hubs/static/client/app/widgets/halp/HubsList.js
new file mode 100644
index 0000000..9f39afe
--- /dev/null
+++ b/hubs/static/client/app/widgets/halp/HubsList.js
@@ -0,0 +1,40 @@
+import React from 'react';
+import { defineMessages, FormattedMessage } from 'react-intl';
+import Hub from './Hub';
+
+
+const messages = defineMessages({
+  watching_all_hubs: {
+    id: "hubs.widgets.halp.watching_all_hubs",
+    defaultMessage: "Watching all hubs"
+  },
+});
+
+
+export default class HubsList extends React.Component {
+  render() {
+    var hubNodes = this.props.hubs.map(function(hub, idx) {
+      return (
+        <Hub
+          name={hub.name}
+          active={hub.active}
+          onClick={this.props.onHubClick}
+          key={idx}
+          />
+      );
+    }.bind(this));
+    return (
+      <div className="hubs">
+        <span className="fa fa-tags" aria-hidden="true"></span>
+        { (hubNodes.length !== 0) ?
+            hubNodes
+          :
+            <FormattedMessage
+              tagName="em"
+              {...messages.watching_all_hubs}
+              />
+        }
+      </div>
+    );
+  }
+}
diff --git a/hubs/static/client/app/widgets/halp/ModalAllRequests.js b/hubs/static/client/app/widgets/halp/ModalAllRequests.js
new file mode 100644
index 0000000..8f0e1a8
--- /dev/null
+++ b/hubs/static/client/app/widgets/halp/ModalAllRequests.js
@@ -0,0 +1,238 @@
+import React from 'react';
+import { defineMessages, FormattedMessage } from 'react-intl';
+import CompletionInput from '../../components/CompletionInput';
+import Spinner from "../../components/Spinner";
+import Modal from '../../components/Modal';
+import Request from './Request';
+
+
+const messages = defineMessages({
+  no_request_found: {
+    id: "hubs.widgets.halp.no_request_found",
+    defaultMessage: "No request found."
+  },
+  search_meeting_name: {
+    id: "hubs.widgets.halp.search.meeting_name",
+    defaultMessage: "Meeting name"
+  },
+  search_between_dates: {
+    id: "hubs.widgets.halp.search.between_dates",
+    defaultMessage: "Between dates"
+  },
+  search_people: {
+    id: "hubs.widgets.halp.search.people",
+    defaultMessage: "People"
+  },
+  search_button: {
+    id: "hubs.widgets.halp.search.button",
+    defaultMessage: "Search"
+  },
+  pager_newer: {
+    id: "hubs.widgets.halp.pager.newer",
+    defaultMessage: "Newer"
+  },
+  pager_older: {
+    id: "hubs.widgets.halp.pager.older",
+    defaultMessage: "Older"
+  },
+  pager_status: {
+    id: "hubs.widgets.halp.pager.status",
+    defaultMessage: "Page {page} / {total}"
+  },
+});
+
+
+export default class ModalAllRequests extends React.Component {
+
+  constructor(props) {
+    super(props);
+    this.state = {
+      requests: [],
+      page: {nr: 1, has_prev: false, has_next: false},
+      formData: {
+        hubs: this.props.hubs.filter(
+            function(hub) { return hub.active; }
+          ).map(
+            function(hub) { return hub.name; }
+          ),
+        },
+      isLoading: false,
+    };
+    this.onSubmit = this.onSubmit.bind(this);
+    this.loadFromServer = this.loadFromServer.bind(this);
+    this.onPageChange = this.onPageChange.bind(this);
+    this.handleChange = this.handleChange.bind(this);
+  }
+
+  componentDidMount() {
+    if (this.state.requests.length === 0) {
+      this.loadFromServer();
+    }
+  }
+
+  componentWillUnmount() {
+    if (this.serverRequest) {
+      this.serverRequest.abort()
+    };
+  }
+
+  onSubmit(e) {
+    e.preventDefault();
+    this.loadFromServer();
+  }
+
+  onPageChange(e) {
+    const inc = parseInt(e.target.value);
+    const requestedPage = this.state.page.nr + inc;
+    this.loadFromServer(requestedPage);
+  }
+
+  loadFromServer(requestedPage) {
+    const formData = this.state.formData;
+    formData.page = requestedPage || 1;
+    this.setState({isLoading: true});
+    this.serverRequest = $.ajax({
+      url: this.props.urls.search,
+      method: 'GET',
+      data: formData,
+      dataType: 'json',
+      cache: false,
+      success: function(data) {
+        this.setState({
+          requests: data.data.requests,
+          page: data.page,
+          isLoading: false
+        });
+      }.bind(this),
+      error: function(xhr, status, err) {
+        console.error(this.props.urls.search, status, err.toString());
+        this.setState({isLoading: false});
+      }.bind(this)
+    });
+  }
+
+  handleChange(e) {
+    const name = e.target.name;
+    const value = e.target.type === 'checkbox' ? e.target.checked : e.target.value;
+    this.setState((prevState, props) => {
+      prevState.formData[name] = value;
+      return {formData: prevState.formData};
+    });
+  }
+
+  render() {
+    let footer;
+    if (this.state.requests.length === 0
+        || (!this.state.page.has_prev && !this.state.page.has_next)) {
+      // No results or only one page: don't show the pager.
+      footer = null;
+    } else {
+      footer = (
+        <nav aria-label="...">
+          <ul className="pager">
+            <li className={"pager-prev" + (this.state.page.has_prev ? "" : " disabled")}>
+              <button className="btn btn-link" value="-1" onClick={this.onPageChange}>
+                <span aria-hidden="true">&larr;</span>
+                <FormattedMessage {...messages.pager_newer} />
+              </button>
+            </li>
+            <FormattedMessage
+              tagName="li"
+              {...messages.pager_status}
+              values={{page: this.state.page.nr, total: this.state.page.total_pages}}
+              />
+            <li className={"pager-next" + (this.state.page.has_next ? "" : " disabled")}>
+              <button className="btn btn-link" value="1" onClick={this.onPageChange}>
+                <FormattedMessage {...messages.pager_older} />
+                <span aria-hidden="true">&rarr;</span>
+              </button>
+            </li>
+          </ul>
+        </nav>
+      );
+    }
+
+    let requestNodes;
+    if (this.state.requests.length === 0) {
+      requestNodes = (
+        <p className="no-request">
+          <FormattedMessage {...messages.no_request_found} />
+        </p>
+      );
+    } else {
+      requestNodes = this.state.requests.map((request, idx) => {
+        return (
+          <Request
+            request={request}
+            showdate={false}
+            onZoomRequest={this.props.onZoomRequest}
+            key={idx} />
+        );
+      });
+    }
+
+    return (
+      <Modal
+        title={this.props.title}
+        footer={footer}
+        onCloseClicked={this.props.onCloseClicked}
+        cssClass="ModalAllRequests"
+        >
+        <form className="" method="post"
+              action={this.props.urls.search} onSubmit={this.onSubmit}>
+          <div className="form-group row">
+            <label htmlFor="meetingname" className="col-sm-4 control-label">
+              <FormattedMessage {...messages.search_meeting_name} />
+            </label>
+            <div className="col-sm-8">
+              <input type="text" className="form-control" name="meetingname"
+                     onChange={this.handleChange} />
+            </div>
+          </div>
+          <div className="form-group row">
+            <label htmlFor="startdate" className="col-sm-4 control-label">
+              <FormattedMessage {...messages.search_between_dates} />
+            </label>
+            <div className="col-sm-4">
+              <input type="date" className="form-control" name="startdate"
+                     onChange={this.handleChange} />
+            </div>
+            <div className="col-sm-4">
+              <input type="date" className="form-control" name="enddate"
+                     onChange={this.handleChange} />
+            </div>
+          </div>
+          <div className="form-group row">
+            <label htmlFor="people" className="col-sm-4 control-label">
+              <FormattedMessage {...messages.search_people} />
+            </label>
+            <div className="col-sm-8">
+              <CompletionInput
+                inputProps={{name: "people"}}
+                url={this.props.urls.requesters}
+                onChange={this.handleChange}
+                />
+            </div>
+          </div>
+          <div className="form-group row">
+            <div className="offset-sm-4 col-sm-8">
+              <button
+                type="submit"
+                className="btn btn-primary mr-3"
+                >
+                <FormattedMessage {...messages.search_button} />
+              </button>
+              { this.state.isLoading &&
+                  <Spinner circle={true} />
+              }
+            </div>
+          </div>
+        </form>
+        <hr />
+        <div className="requests">
+          {requestNodes}
+        </div>
+      </Modal>
+    );
+  }
+}
diff --git a/hubs/static/client/app/widgets/halp/ModalRequest.js b/hubs/static/client/app/widgets/halp/ModalRequest.js
new file mode 100644
index 0000000..36ed228
--- /dev/null
+++ b/hubs/static/client/app/widgets/halp/ModalRequest.js
@@ -0,0 +1,111 @@
+import React from 'react';
+import { defineMessages, FormattedMessage } from 'react-intl';
+import Modal from '../../components/Modal';
+import getRequestView from './getRequestView';
+
+
+const messages = defineMessages({
+  zoom_part2_title: {
+    id: "hubs.widgets.halp.zoom.part2_title",
+    defaultMessage: "Want to help with this request?"
+  },
+  zoom_part2_subtitle: {
+    id: "hubs.widgets.halp.zoom.part2_subtitle",
+    defaultMessage: "Awesome! Here's some tips on getting started:"
+  },
+  zoom_tip1: {
+    id: "hubs.widgets.halp.zoom.tip1",
+    defaultMessage: "Take a look at the link provided in the request. It should have more information about the problem and may have instructions on how to get starter helping out:"
+  },
+  zoom_tip2: {
+    id: "hubs.widgets.halp.zoom.tip2",
+    defaultMessage: "Contact the person who requested help to get more information. By clicking on their name, you'll be taken to their profile where you can contact them:"
+  },
+  zoom_tip3: {
+    id: "hubs.widgets.halp.zoom.tip3",
+    defaultMessage: "Read through the chat log where the request occured. There may be additional context in the log that can help you figure out how to get started:"
+  },
+});
+
+
+export default class ModalRequest extends React.Component {
+
+  render() {
+    let content;
+    if (!this.props.data) {
+      content = "";
+    } else {
+      content = (
+        <div className="zoomed-request">
+          {getRequestView(this.props.data)}
+          <hr />
+          <FormattedMessage
+            tagName="h4"
+            {...messages.zoom_part2_title}
+            />
+          <FormattedMessage
+            tag="p"
+            {...messages.zoom_part2_subtitle}
+            />
+          <ol>
+            { this.props.data.urls ?
+            <li>
+              <FormattedMessage
+                {...messages.zoom_tip1}
+                />
+              <ul>
+                { this.props.data.urls.map(function(url, index) {
+                  return (
+                    <li key={index}><a href={url}>
+                      {url.replace(/^https?:\/\//, '')}
+                    </a></li>);
+                  }) }
+              </ul>
+            </li>
+            : null }
+            <li>
+              <FormattedMessage
+                {...messages.zoom_tip2}
+                />
+              <ul className="list-unstyled">
+                <li className="media">
+                  <div className="media-left media-middle">
+                    <a href={this.props.data.author.url} target="_blank">
+                      <img className="square-32 img-circle"
+                           src={this.props.data.author.avatar} />
+                    </a>
+                  </div>
+                  <div className="media-body">
+                    <a href={this.props.data.author.url} target="_blank">
+                      {this.props.data.author.name}
+                    </a>
+                  </div>
+                </li>
+              </ul>
+            </li>
+            <li>
+              <FormattedMessage
+                {...messages.zoom_tip3}
+                />
+              <ul className="list-unstyled">
+                <a href={this.props.data.context_url}>
+                  {this.props.data.context_url.replace(/^https?:\/\//, '')}
+                </a>
+              </ul>
+            </li>
+          </ol>
+        </div>
+      );
+    }
+
+    return (
+      <Modal
+        title={this.props.title}
+        onCloseClicked={this.props.onCloseClicked}
+        cssClass="ModalRequest"
+        >
+        {content}
+      </Modal>
+    );
+  }
+}
diff --git a/hubs/static/client/app/widgets/halp/Request.js b/hubs/static/client/app/widgets/halp/Request.js
new file mode 100644
index 0000000..a6c0ec9
--- /dev/null
+++ b/hubs/static/client/app/widgets/halp/Request.js
@@ -0,0 +1,37 @@
+import React from 'react';
+import {FormattedRelative} from 'react-intl';
+import getRequestView from './getRequestView';
+
+
+export default class Request extends React.Component {
+
+  constructor(props) {
+    super(props);
+    this.onClick = this.onClick.bind(this);
+  }
+
+  onClick(e) {
+    e.preventDefault;
+    this.props.onZoomRequest(this.props.request);
+  }
+
+  render() {
+    var requestView = getRequestView(
+      this.props.request,
+      this.props.onZoomRequest ? this.onClick : null);
+    return (
+      <div>
+        { this.props.showdate ?
+            <div className="date text-uppercase">
+              <FormattedRelative value={new Date(this.props.request.date * 1000)} />
+            </div>
+          : ""
+        }
+        {requestView}
+      </div>
+    );
+  }
+}
+Request.defaultProps = {
+    onZoomRequest: null,
+};
